!-----Based on ABFLUX.F in CCTM module----!
      MODULE CNNONAG_CYCLE_MOD
	  USE ASX_DATA_MOD
      IMPLICIT NONE
C      REAL,    ALLOCATABLE, SAVE :: NDEPRATE  ( :,: )  ! "ng N m-2 s-1"
C      LOGICAL, SAVE     :: BDSNP
C      LOGICAL, SAVE     :: EPIC
       LOGICAL, SAVE     :: CNNONAGCYCLE
! shared variables used in module and subroutines
C      Real, Save, Allocatable :: frac_ir( :,: ) ! irrigated fraction of ag
c      Real, Save, Allocatable:: fagam1 ( :,: ) ! due to fertilizer app
c      Real, Save, Allocatable :: fagam2 ( :,: ) ! due to fertilizer app
C      Real, Save, Allocatable :: NH4L1 ( :,:,: ) ! Initial Soil L1_NH4
C      Real, Save, Allocatable :: NH4L2 ( :,:,: ) ! Initial Soil L2_NH4
      Real, Save, Allocatable :: NH4 ( :,: ) ! Total soil NH4 
C      Real, Save, Allocatable :: NO3L1 ( :,:,: ) ! Initial Soil L1_NO3
C      Real, Save, Allocatable :: NO3L2 ( :,:,: ) ! Initial Soil L2_NO3
      Real, Save, Allocatable :: NO3 ( :,: ) ! Total soil NO3 
      Real, Save, Allocatable :: pHsl ( :,: ) ! Area weighted soil pH
C      Real, Save, Allocatable :: CL1 ( :,:,: ) ! Initial Soil L1_C
C      Real, Save, Allocatable :: CL2 ( :,:,: ) ! Initial Soil L2_C
      Real, Save, Allocatable :: Carbon ( :,: ) ! Soil microbial C 
      Real, Save, Allocatable :: LiableC ( :, : ) ! Total Liable C
      Real, Save, Allocatable :: Rm ( :, : ) ! Co2 respiration maintainence
      Real, Save, Allocatable :: Re ( :, : ) ! CO2 resp enzyme
      Real, Save, Allocatable :: Rg ( :, : ) ! CO2 resp growth
      Real, Save, Allocatable :: Ro ( :, : ) ! CO2 overflow
      Real, Save, Allocatable :: EPc ( :, : ) ! Enzyme production
      Real, Save, Allocatable :: CYc ( :, : ) ! Recycle   
      Real, Save, Allocatable :: Hc ( :, : ) ! Decay   
 
C      Real, Save, Allocatable :: pHs2   ( :,:,: )
!      Real, Save, Allocatable :: pHs2   ( :,:,: ) 
!      REAL,    ALLOCATABLE, SAVE :: DRYPERIOD( :,: )  ! Will determine pulse, hours
!      REAL,    ALLOCATABLE, SAVE :: PFACTOR  ( :,: )  ! current pulse factor
!      REAL,    ALLOCATABLE, SAVE :: SOILMPREV( :,: )  ! soil moisture previous tstep [m3/m3] (PX)
!      INTEGER, ALLOCATABLE, Save :: LANDFRAC( :,: )
      REAL,    ALLOCATABLE, SAVE :: SMN( :,: )  !Soil microbial N, g N/m2
      REAL,    ALLOCATABLE, SAVE :: SMC( :,: )  !Soil microbial C, g C/m2
      REAL                       :: AW_SMN ! area weighted SMN               	  
	  REAL                       :: AW_SMC ! area weighted SMC                	  
      REAL,    ALLOCATABLE, SAVE :: CNm( :,: )  !Soil microbial CtoN ratio
!      CHARACTER( 16 ), SAVE :: LANDFRACFILE = 'LANDFRACFILE' !biome type 
      CHARACTER( 16 ), SAVE :: SMNRESFILE = 'SMNRESFILE' ! Soil Microbial N
      CHARACTER( 16 ), SAVE :: SMCRESFILE = 'SMCRESFILE' ! Soil Microbial C
      CHARACTER( 16 ), SAVE :: CNRATIOFILE = 'CNRATIOFILE' ! Microbial CtoN ratio
      CHARACTER( 16 ), SAVE :: PHTOPSOILFILE = 'PHTOPSOILFILE' !pH file    
      
!      INTEGER, PARAMETER :: NBIOME    = 24  !USGS 24 LU/biome type
      ! Xu et al, 2013 A_Cmic and A_Nmic % values, mapped to
      ! each of the 24 soil biomes
      ! [https://daac.ornl.gov/daacdata/global_soil/Global_Microbial_Biomass_C_N_P/comp/XuXF2013_GEB.pdf]
      ! 1.2 % Cmc/Corg and 2.6% Nmic/Ntot are global average
!      REAL*8,  PARAMETER :: A_Cmic(NBIOME)          =                (/
!     &   0.00, 0.012, 0.00, 0.0502, 0.00, 0.0502, 0.0143, 0.0143, 
!     &   0.0143, 0.0166, 0.0166, 0.0209, 0.0209, 0.0209, 0.0129, 0.0099,
!     &   0.0116, 0.0099, 0.0176, 0.0116, 0.0179, 
!     &   0.0167, 0.00, 0.0146     /)
      
!       REAL*8,  PARAMETER :: A_Nmic(NBIOME)          =                (/
!     &   0.00, 0.0258, 0.00, 0.0572, 0.00, 0.0572, 0.0233, 0.0233,
!     &   0.0233, 0.0361, 0.0361, 0.0428, 0.0428, 0.0428, 0.028, 0.0262,
!     &   0.0242, 0.0262, 0.0418, 0.0242, 0.0308, 
!     &   0.0253, 0.00, 0.0262     /)

C      Real, Save,              Private :: C_gam           ! Canadian fertilizer facter
c      Real, Parameter,         Private :: maxgam   = 2.0e5 ! maximum soil gamm. It is assumed that any excess NH4 would from salts
c      Real, Parameter,         Private :: natgam   = 20.0  ! Background soil gamma
! Schimel and Weintraub Soil Biology & Biochem., 2003- Microbial C and N
! in soil- Theoretical model
      Real, Parameter,         Private :: Ke = 0.05 !Fraction of Biome C to exoenzymes  
      Real, Parameter,         Private :: Km = 0.01 !d^-1, microbial  maintainence rate
      Real, Parameter,         Private :: SUE = 0.5 !Fraction, Substrate Use efficiency      
      Real, Parameter,         Private :: Kt = 0.012 !d^-1, Proportion of Microbial biomass that dies per day
      Real, Parameter,         Private :: Kr = 0.85 !Proportion of microbial biomass (C or N) for microbial use

      Contains
        Subroutine Init_CNnonAgcycle( jdate, jtime )
       
         Use HGRD_DEFN           ! horizontal grid specifications
C        USE GRID_CONF           ! horizontal & vertical domain specifications
         Use UTILIO_DEFN
C         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2

         Implicit None
! Includes
         Include SUBST_CONST     ! constants
         Include SUBST_FILES_ID  ! file name parameters

! Local Variables

         Integer, Intent( In )  :: jdate
         Integer, Intent( In )  :: jtime
         Integer                :: c,r,l,k,j,i
C         Integer, Parameter :: e2c_cats = 42   ! number of crop categories
         Integer            :: gxoff, gyoff    ! global origin offset from file
         integer, save      :: strtcol, endcol, strtrow, endrow
         Integer, Save      :: loagdev 
         CHARACTER( 256 ) :: MESG
         INTEGER, SAVE :: LOGDEV
         INTEGER          IOS                ! IO or memory allocation status

c         Real, Save, Allocatable :: F_rate1 ( :,:,: ) ! fertlizer application to layer 1
c         Real, Save, Allocatable :: F_rate2 ( :,:,: ) ! fertlizer application to layer 2

!         Real, Save, Allocatable :: Beld_ag ( :,:,: )
!         Real                    :: Tot_Ag          ! total ag in the grid cell
C         Real, Parameter :: convl1 = 7.142857e-04   ! ha/m**2 * mol/g N * 1/z_soil_l1
C         Real, Parameter :: convl2 = 1.428571e-04   ! ha/m**2 * mol/g N * 1/z_soil_l2
C         Real            :: pHfac1
C         Real            :: pHfac2

         Character( 16 ), Parameter :: pname = 'Init_CNnonAgcycle'
         Character( 16 )            :: vname
         Character( 96 )            :: xmsg = ' '
         INTEGER, PARAMETER :: NSOIL    = 24  !USGS 24 LU/biome type
      ! Xu et al, 2013 A_Cmic and A_Nmic % values, mapped to
      ! each of the 24 soil biomes
      ! [https://daac.ornl.gov/daacdata/global_soil/Global_Microbial_Biomass_C_N_P/comp/XuXF2013_GEB.pdf]
      ! 1.2 % Cmc/Corg and 2.6% Nmic/Ntot are global average
	  !*****************************************************************************************************************
	  !*****************************************************************************************************************
	  !*****************************************************************************************************************
	  ! These need to be defined for the NLCD 40 land use types
         REAL*8,  PARAMETER :: A_Cmic(40)    =                 (/
     &     0.0176, 0.0099, 0.0179, 0.0116, 0.0129, 0.0143, 0.0143, 
     &     0.0209, 0.0166, 0.0209, 0.012, 0.0167, 0.00, 0.0146, 0.00,
     &     0.0502, 0.00, 0.0502, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     &     0.00, 0.0, 0.0, 0.0099, 0.0176, 0.0129, 0.0143,
     &     0.0143, 0.0209, 0.0209, 0.0209, 0.0209, 0.0,
     &     0.0, 0.012, 0.012     /)

         REAL*8,  PARAMETER :: A_Nmic(40)      =               (/
     &     0.0418, 0.0262, 0.0308, 0.0242, 0.028, 0.0233, 0.0233,
     &     0.0428, 0.0361, 0.0428, 0.0258, 0.0253, 0.00, 0.0262, 0.00,
     &     0.0572, 0.00, 0.0572, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     &     0.00, 0.0, 0.0, 0.0262, 0.0418, 0.028, 0.0233,
     &     0.0233, 0.0428, 0.0428, 0.0428, 0.0428, 0.0,
     &     0.0, 0.0258, 0.0258     /)
	 !*****************************************************************************************************************
	 !*****************************************************************************************************************
	 !*****************************************************************************************************************
    
!         Character( 20 ), Save      :: Beld_Names( e2c_cats )
C Some compilers do not pad with blank characters in data initialization
C                          '12345678901234567890'
!         Data Beld_Names / 'Hay                 ',  !  1
!     &                     'Hay_ir              ',  !  2
!     &                     'Alfalfa             ',  !  3
!     &                     'Alfalfa_ir          ',  !  4
!     &                     'Other_Grass         ',  !  5
!     &                     'Other_Grass_ir      ',  !  6
!     &                     'Barley              ',  !  7
!     &                     'Barley_ir           ',  !  8
!     &                     'BeansEdible         ',  !  9
!     &                     'BeansEdible_ir      ',  ! 10
!     &                     'CornGrain           ',  ! 11
!     &                     'CornGrain_ir        ',  ! 12
!     &                     'CornSilage          ',  ! 13
!     &                     'CornSilage_ir       ',  ! 14
!     &                     'Cotton              ',  ! 15
!     &                     'Cotton_ir           ',  ! 16
!     &                     'Oats                ',  ! 17
!     &                     'Oats_ir             ',  ! 18
!     &                     'Peanuts             ',  ! 19
!     &                     'Peanuts_ir          ',  ! 20
!     &                     'Potatoes            ',  ! 21
!     &                     'Potatoes_ir         ',  ! 22
!     &                     'Rice                ',  ! 23
!     &                     'Rice_ir             ',  ! 24
!     &                     'Rye                 ',  ! 25
!     &                     'Rye_ir              ',  ! 26
!     &                     'SorghumGrain        ',  ! 27
!     &                     'SorghumGrain_ir     ',  ! 28
!     &                     'SorghumSilage       ',  ! 29
!     &                     'SorghumSilage_ir    ',  ! 30
!     &                     'Soybeans            ',  ! 31
!     &                     'Soybeans_ir         ',  ! 32
!     &                     'Wheat_Spring        ',  ! 33
!     &                     'Wheat_Spring_ir     ',  ! 34
!     &                     'Wheat_Winter        ',  ! 35
!     &                     'Wheat_Winter_ir     ',  ! 36
!     &                     'Other_Crop          ',  ! 37
!     &                     'Other_Crop_ir       ',  ! 38
!     &                     'Canola              ',  ! 39
!     &                     'Canola_ir           ',  ! 40
!     &                     'Beans               ',  ! 41
!     &                     'Beans_ir            ' / ! 42
         logdev =  init3()
! Find the Canadian fertilizer factor based off of Sheppard et al 2010
! Canadian J. Soil Sci. &
! Zhang et al. 2010 JGR
c         Select Case( jdate )
c            Case(  60:90 )
c               C_gam = 811.5
c            Case(  91:120 )
c               C_gam = 3447.3
c            Case( 121:151 )
c               C_gam = 8702.8
c            Case( 152:181 )
c               C_gam = 1269.3
c           Case( 182:212 )
c               C_gam = 667.1
c            Case( 213:243 )
c               C_gam = 704.2
c            Case( 244:273 )
c               C_gam = 811.5
c            Case( 274:304 )
c               C_gam = 1376.7
c            Case( 305:334 )
c              C_gam = 1079.6
c            Case Default
c               C_gam = 630.0
c         End Select

! time in the files is not the same
C         If ( .Not. Open3( E2C_SOIL, fsread3, pname ) ) Then
C           xmsg = 'Could not open '// E2C_SOIL // ' file'
C           Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
C         End If

!         Call Subhfile ( E2C_SOIL, gxoff, gyoff, strtcol, endcol, strtrow, endrow )

!         If ( .Not. Allocated ( pHs2 ) ) Then
!            Allocate ( pHs2 ( my_ncols,my_nrows,e2c_cats ) )
!         End If

!         vname = 'L2_PH'
!         If ( .Not. Xtract3 ( E2C_SOIL, vname, 1, e2c_cats, strtrow, endrow,
!     &                        strtcol, endcol, jdate, 0, pHs2 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_SOIL
!            Go To 1001
!         End If
!         If ( .Not. Allocated ( pHs2 ) ) Then
c            Allocate ( pHs2 ( my_ncols,my_nrows,e2c_cats ) )
C         End If

C         vname = 'L2_PH'
c         If ( .Not. Xtract3 ( E2C_SOIL, vname, 1, e2c_cats, strtrow, endrow,
C     &                        strtcol, endcol, jdate, 0, pHs2 ) ) Then
C            Write( xmsg,9001 ) vname, E2C_SOIL
C            Go To 1001
C         End If
! get BELD4 land use types time independent files.
!         If ( .Not. Open3( BELD4_LU, fsread3, pname ) ) Then
!           xmsg = 'Could not open '// BELD4_LU // ' file'
!           Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
!         End If
!         If ( .Not. Allocated ( Beld_ag ) ) Then
!            Allocate ( Beld_ag ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         Do k = 1, e2c_cats
!            vname = BELD_Names(k)
!            If ( .Not. Interpx ( BELD4_LU, vname, pname, strtcol, endcol,
!     &                           strtrow, endrow, 1, 1, jdate, jtime,
!     &                           Beld_ag( :,:,k ) ) ) Then
!               Write( xmsg,9001 ) vname, BELD4_LU
!               Go To 1001
!            End If
!         End Do
!         Beld_ag = 0.01 * Beld_ag   ! convert to fraction
    


c             IF ( .NOT. XTRACT3( LANDFRACFILE, 'LANDFRAC',
c     & 1,1, strtrow, endrow, strtcol, endcol,
c     & 0, 0, LANDFRAC ) ) THEN
c         MESG = 'Could not open LANDFRAC file'
c         CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
c      END IF
C      Write(LOGDEV,*) 'about to extract lfrac, NCOLS,NROWS', NCOLS,
C      NROWS
c      IF ( .NOT. XTRACT3( LANDFRACFILE, 'LANDFRAC',
c     & 1,1, strtrow, endrow, strtcol, endcol,
c     & 0, 0, LANDFRAC ) ) THEN
c       MESG = 'Could not read LANDFRAC from LANDFRACFILE'
c       CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
c      END IF    
C Get description of NO soil state data file
!            IF ( .NOT. DESC3( SMNRESFILE ) ) THEN
!               MESG = 'Could not get description of file "' //
!     &                 TRIM( SMNRESFILE ) // '"'
!               CALL M3EXIT( PNAME, 0, 0, MESG, XSTAT1 )
!            END IF
C Get domain decomp info for the NO soil state data file
       ALLOCATE( SMN( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SMN30cm', PNAME )
!          If ( .Not. Allocated ( SMN ) ) Then
!            Allocate ( SMN ( my_ncols,my_nrows ) )
!         End If 
       ALLOCATE( SMC( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SMC30cm', PNAME )
!          If ( .Not. Allocated ( SMC ) ) Then
!            Allocate ( SMC ( my_ncols,my_nrows ) )
!         End If
       ALLOCATE( CNm( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'CN30cm', PNAME )
!          If ( .Not. Allocated ( CNm ) ) Then
!            Allocate ( CNm ( my_ncols,my_nrows ) )
!         End If
       ALLOCATE( pHsl( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'pHsl', PNAME )
!          If ( .Not. Allocated ( pHsl ) ) Then
!            Allocate ( pHsl ( my_ncols,my_nrows ) )
!         End If 
            CALL SUBHFILE ( SMNRESFILE, GXOFF, GYOFF,
     &                      strtcol, endcol, strtrow, endrow )
         If ( .Not. Open3( SMNRESFILE, fsread3, pname ) ) Then
           mesg = 'Could not open '// SMNRESFILE // ' file'
           Call M3exit ( pname, jdate, jtime, mesg, xstat1 )
         End If
             IF ( .NOT. XTRACT3( SMNRESFILE, 'SMN30cm',
     & 1,1, strtrow, endrow, strtcol, endcol,
     & 0, 0, SMN ) ) THEN
       MESG = 'Could not read SMN from SMNRESFILE'
       CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
      END IF
C      Write(LOGDEV,*) 'about to extract SMN, NCOLS,NROWS', NCOLS, NROWS
         If ( .Not. Open3( SMCRESFILE, fsread3, pname ) ) Then
           mesg = 'Could not open '// SMCRESFILE // ' file'
           Call M3exit ( pname, jdate, jtime, mesg, xstat1 )
         End If
             IF ( .NOT. XTRACT3( SMCRESFILE, 'SMC30cm',
     & 1,1, strtrow, endrow, strtcol, endcol,
     & 0, 0, SMC ) ) THEN
       MESG = 'Could not read SMC from SMCRESFILE'
       CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
      END IF
C      Write(LOGDEV,*) 'about to extract SMC, NCOLS,NROWS', NCOLS, NROWS
         If ( .Not. Open3( CNRATIOFILE, fsread3, pname ) ) Then
           mesg = 'Could not open '// CNRATIOFILE // ' file'
           Call M3exit ( pname, jdate, jtime, mesg, xstat1 )
         End If
             IF ( .NOT. XTRACT3( CNRATIOFILE, 'CN30cm',
     & 1,1, strtrow, endrow, strtcol, endcol,
     & 0, 0, CNm ) ) THEN
       MESG = 'Could not read CNm from CNRATIOFILE'
       CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
      END IF
C      Write(LOGDEV,*) 'about to extract CNm, NCOLS,NROWS', NCOLS, NROWS   
         If ( .Not. Open3( PHTOPSOILFILE, fsread3, pname ) ) Then
           mesg = 'Could not open '// PHTOPSOILFILE // ' file'
           Call M3exit ( pname, jdate, jtime, mesg, xstat1 )
         End If
             IF ( .NOT. XTRACT3( PHTOPSOILFILE, 'pHsl',
     & 1,1, strtrow, endrow, strtcol, endcol,
     & 0, 0, pHsl ) ) THEN
         MESG = 'Could not open pHtopsoil file'
         CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
      END IF  


! Allocate variable needed for soil processes, nitr-denitr and fertilization
c         If ( .Not. Allocated ( gamma1 ) ) Then
c            Allocate ( gamma1 ( my_ncols,my_nrows ) )
c         End If
c         gamma1 = 0.0
c         If ( .Not. Allocated ( gamma2 ) ) Then
c            Allocate ( gamma2 ( my_ncols,my_nrows ) )
c         End If
c         gamma2 = 0.0
c         If ( .Not. Allocated ( fagam1 ) ) Then
c            Allocate ( fagam1 ( my_ncols,my_nrows ) )
c         End If
c         fagam1 = 0.0
c         If ( .Not. Allocated ( fagam2 ) ) Then
c            Allocate ( fagam2 ( my_ncols,my_nrows ) )
c         End If
c         fagam2 = 0.0
c         If ( .Not. Allocated ( MHp1 ) ) Then
c            Allocate ( MHp1 ( my_ncols,my_nrows ) )
c         End If
c         MHp1 = 0.0
c         If ( .Not. Allocated ( MHp2 ) ) Then
c            Allocate ( MHp2 ( my_ncols,my_nrows ) )
c         End If
c         MHp2 = 0.0


         If ( .Not. Allocated ( Re ) ) Then
            Allocate ( Re ( my_ncols,my_nrows ) )
         End If
         Re = 0.0
         If ( .Not. Allocated ( Rm ) ) Then
            Allocate ( Rm ( my_ncols,my_nrows ) )
         End If
         Rm = 0.0
         If ( .Not. Allocated ( Rg ) ) Then
            Allocate ( Rg ( my_ncols,my_nrows ) )
         End If
         Rg = 0.0
         If ( .Not. Allocated ( Ro ) ) Then
            Allocate ( Ro ( my_ncols,my_nrows ) )
         End If
         Ro = 0.0
         If ( .Not. Allocated ( EPc ) ) Then
            Allocate ( EPc ( my_ncols,my_nrows ) )
         End If
         EPc = 0.0
         If ( .Not. Allocated ( CYc ) ) Then
            Allocate ( CYc ( my_ncols,my_nrows ) )
         End If
         CYc = 0.0
         If ( .Not. Allocated ( Hc ) ) Then
            Allocate ( Hc ( my_ncols,my_nrows ) )
         End If
         Hc = 0.0

C         ALLOCATE( DRYPERIOD( my_ncols,my_nrows ), STAT=IOS )
C         CALL CHECKMEM( IOS, 'PTYPE', pname ) 
!          If ( .Not. Allocated ( DRYPERIOD ) ) Then
!            Allocate ( DRYPERIOD ( my_ncols,my_nrows ) )
!         End If
!         DRYPERIOD = 0.0
c         ALLOCATE( PFACTOR( my_ncols,my_nrows ), STAT=IOS )
C         CALL CHECKMEM( IOS, 'PTYPE', pname )
!          If ( .Not. Allocated ( PFACTOR ) ) Then
!            Allocate ( PFACTOR ( my_ncols,my_nrows ) )
!         End If
!         PFACTOR = 0.0         
         
c         ALLOCATE( SOILMPREV( NCOLS,NROWS ), STAT=IOS )
c        CALL CHECKMEM( IOS, 'SOILMPREV', PNAME )
!         If ( .Not. Allocated ( SOILMPREV ) ) Then
!            Allocate ( SOILMPREV ( my_ncols,my_nrows ) )
!         End If
!         SOILMPREV = 0.0
c        ALLOCATE( LANDFRAC( NCOLS,NROWS ), STAT=IOS )^M
c         CALL CHECKMEM( IOS, 'LANDFRAC', PNAME )
!          If ( .Not. Allocated ( LANDFRAC ) ) Then
!            Allocate ( LANDFRAC ( my_ncols,my_nrows ) )
!         End If
c         SOILMPREV = 0.0  
        
!         If ( .Not. Allocated ( frac_ir ) ) Then
!            Allocate ( frac_ir ( my_ncols,my_nrows ) )
!         End If
!         frac_ir = 0.0
         If ( .Not. Allocated ( NH4 ) ) Then
            Allocate ( NH4 ( my_ncols,my_nrows ) )
         End If
         NH4 = 0.0
         If ( .Not. Allocated ( NO3 ) ) Then
            Allocate ( NO3 ( my_ncols,my_nrows ) )
         End If
         NO3 = 0.0
         If ( .Not. Allocated ( Carbon ) ) Then
            Allocate ( Carbon ( my_ncols,my_nrows ) )
         End If
         Carbon = 0.0
         If ( .Not. Allocated ( LiableC ) ) Then
            Allocate ( LiableC ( my_ncols,my_nrows ) )
         End If
         LiableC = 0.0
!         If ( .Not. Allocated ( pHsl ) ) Then
!            Allocate ( pHsl ( my_ncols,my_nrows ) )
!         End If
!         pHsl = 0.0

C         If ( .Not. Allocated ( HONO ) ) Then
C            Allocate ( HONO ( my_ncols,my_nrows ) )
C         End If
C         HONO = 0.0
C         If ( .Not. Allocated ( NITNO ) ) Then
C            Allocate ( NITNO ( my_ncols,my_nrows ) )
C         End If
C         NITNO = 0.0
! get soil N pools NH4 NO3 and C and dates
! time in the files is not the same
c         If ( .Not. Open3( E2C_FERT, fsread3, pname ) ) Then
c           xmsg = 'Could not open '// E2C_FERT // ' file'
c           Call M3exit ( pname, 0, 0, xmsg, xstat1 )
c         End If
! get fertilizer from the previous month to estimate soil NH4+
! time in the files is not the same
         If ( .Not. Open3( INIT_MEDC_1, fsread3, pname ) ) Then
            Write(Logdev,*) 'Estimating nonAg soil NHx NO3 C'
!            Write(Logdev,*) 'Estimating soil NHx NO3 C from EPIC output'
!            If ( .Not. Open3( E2C_FERT, fsread3, pname ) ) Then
!               xmsg = 'Could not open '// E2C_FERT // ' file'
!               Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
!            End If
!         If ( .Not. Allocated ( NH4L1 ) ) Then
!            Allocate ( NH4L1 ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         NH4L1 = 0.0
!         If ( .Not. Allocated ( NH4L2 ) ) Then
!            Allocate ( NH4L2 ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         NH4L2 = 0.0
!         If ( .Not. Allocated ( NO3L1 ) ) Then
!            Allocate ( NO3L1 ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         NO3L1 = 0.0
!         If ( .Not. Allocated ( NO3L2 ) ) Then
!            Allocate ( NO3L2 ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         NO3L2 = 0.0
!         If ( .Not. Allocated ( CL1 ) ) Then
!            Allocate ( CL1 ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         CL1 = 0.0
!         If ( .Not. Allocated ( CL2 ) ) Then
!            Allocate ( CL2 ( my_ncols,my_nrows,e2c_cats ) )
!         End If
!         CL2 = 0.0
!         vname = 'L1_NH3'
!         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
!     &                       strtcol, endcol, jdate, 0, NH4L1 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_FERT
!            Go To 1001
!         End If
!         vname = 'L2_NH3'
!         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
!     &                       strtcol, endcol, jdate, 0, NH4L2 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_FERT
!            Go To 1001
!         End If
!         vname = 'L1_NO3'
!         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
!     &                       strtcol, endcol, jdate, 0, NO3L1 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_FERT
!            Go To 1001
!         End If
!         vname = 'L2_NO3'
!         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
!     &                       strtcol, endcol, jdate, 0, NO3L2 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_FERT
!            Go To 1001
!         End If
!         vname = 'HMN'
!         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
!     &                       strtcol, endcol, jdate, 0, CL1 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_FERT
!            Go To 1001
!         End If
!         vname = 'L2_C'
!         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
!     &                       strtcol, endcol, jdate, 0, CL2 ) ) Then
!            Write( xmsg,9001 ) vname, E2C_FERT
!            Go To 1001
!         End If
! parameters
! Biome 24 LU categories loop
!      Do i=1, NSOIL
!       SMC( c,r ) = SMC( c,r ) * A_Cmic(i)
!       SMN( c,r ) = SMN( c,r ) * A_Nmic(i)
!      End Do ! NSOIL 24 USGS soil biomes



! 1 g/m2 = 10 kg/ha 
            Do r = 1, my_nrows
               Do c = 1, my_ncols
! Biome 24 LU categories loop
!                Do i=1, NSOIL
                Do i=1, 40 !n_lufrac
                 If( .Not. IsNaN( SMN( c,r ) ) .And.
     &                   .Not. IsNaN( SMC( c,r ) ) .And.
     &                   .Not. IsNan( CNm( c,r ) ) .And.
     &                   .Not. IsNan( pHsl( c,r ) )) Then
	                AW_SMC = SMC( c,r ) * A_Cmic(i)
                    AW_SMN = SMN( c,r ) * A_Nmic(i)
                    If ( AW_SMN .Gt. 0.0       .And.
     &                       AW_SMC .Gt. 0.0       .And.
     &                       CNm( c,r ) .Gt. 0.0       .And.
     &                       pHsl( c,r ) .Gt. 0.0 )     Then
                       Rm( c,r ) = Rm( c,r ) + ( (Km * 10.0 * 
     &                       AW_SMC)  )*Grid_Data%LUFRAC( c,r,i )
!Rm kg/ha/d
                       EPc( c,r ) = EPc( c,r ) + ( (Ke * 10.0 * 
     &                       AW_SMC) )*Grid_Data%LUFRAC( c,r,i )
!EPc and Re kg/ha
                       Re( c,r ) = Re( c,r ) + ( ((1-SUE) * 
     &                       EPc( c,r )) / SUE )*Grid_Data%LUFRAC( c,r,i )   
!CYc kg/ha/d
                       CYc( c,r ) = CYc( c,r ) + 
     &                       ( (Kt*Kr*10.0*AW_SMC ) )*Grid_Data%LUFRAC( c,r,i )
                       Hc( c,r ) = Hc( c,r ) + 
     &                       ( (Kt * (1 - Kr) * 10.0 * AW_SMC) )*Grid_Data%LUFRAC( c,r,i )
!kg/ha
                       Carbon( c,r ) = Carbon( c,r ) + ( 
     &                       (AW_SMC*10.0) ) *Grid_Data%LUFRAC( c,r,i )
                       LiableC( c,r ) = LiableC( c,r )+ Carbon( c,r )    
                           If ( ((10.0*AW_SMC)  ) 
     &                            .Lt. ( Rm( c,r )
     &                            + ((EPc( c,r ))/SUE) + ((
     &                            ((10.0*AW_SMN)  )
     &                            - ((EPc( c,r ))/3.0)) * ((CNm(c,r)
     &                            )/ SUE)))) Then
                              Rg( c,r ) = Rg( c,r ) + 
     &                               ( (1-SUE)*( ((10.0*AW_SMC)
     &                               ) - (EPc(c,r)
     &                               /SUE) - Rm(c,r) ) )*Grid_Data%LUFRAC( c,r,i ) 
                              Ro(c,r) = 0.0
                              NH4(c,r) = NH4(c,r)+(( ((10.0*AW_SMN)
     &                               )
     &                               - (EPc (c,r)/3.0))-(( 
     &                               ((10.0*AW_SMC) ) 
     &                               - ( EPc(c,r)
     &                               /SUE) - Rm( c,r ))*(SUE/CNm
     &                               (c,r))))*Grid_Data%LUFRAC( c,r,i )
                              NO3( c,r ) = 0.0  
C                            Else
!                              Rg( c,r ) = Rg( c,r ) + ((CNm(c,r) *
!     &                               ( 1 - SUE ) ) / SUE ) * 
!     &                               ( ((10.0*SMN(c,r)) ) - 
!     &                               (EPc(c,r)
!     &                               /3.0) ) 
!                              Ro(c,r) = Ro(c,r) + ( ((10.0*SMC(c,r))
!     &                               ) - (EPc(c,r)
!     &                               /SUE) - Rm(c,r)) - ((CNm(c,r) 
!     &                               / SUE ) *
!     &                               ( ((10.0*SMN(c,r) )) 
!     &                               - (EPc(c,r)
!     &                               /3.0) ) )
C                              NH4( c,r ) = 0.0
C                              NO3( c,r ) = 0.0
                           End If 
                    End If
                 End If
                End Do ! landfrac nlcd40 soil biomes  
   
!                        NH4( c,r ) = NH4( c,r ) + (NH4L1( c,r )
!     &                                     * Beld_ag( c,r,l ) )
!     &                                     + (NH4L2( c,r,l )
!     &                                      * Beld_ag(c,r,l ) )
!                           NO3( c,r ) = NO3( c,r ) + (NO3L1( c,r )
!     &                                     * Beld_ag( c,r,l ) )
!     &                                     + (NO3L2( c,r,l )
!     &                                      * Beld_ag(c,r,l ) )
!                           Carbon( c,r ) = Carbon( c,r ) + (CL1( c,r )
!     &                                     * Beld_ag( c,r,l ) )

 
!                  Tot_Ag = 0.0
!                  Do l = 1, e2c_cats
!                     If( .Not. IsNaN( NH4L1( c,r,l ) ) .And.
!     &                   .Not. IsNaN( NH4L2( c,r,l ) ) .And.
!     &                   .Not. IsNan( NO3L1( c,r,l ) ) .And.
!     &                   .Not. IsNan( NO3L2( c,r,l ) ) .And.
!     &                   .Not. IsNan( CL1( c,r,l ) ) .And.
!     &                   .Not. IsNan( CL2( c,r,l ) ) .And.
!     &                   .Not. IsNan( pHs2( c,r,l ) ) .And.
!     &                    Beld_ag( c,r,l ) .Gt. 0.0 ) Then
! convert units from kg/ha N to mol/l
!                        If ( NH4L1( c,r,l ) .Gt. 0.0       .And.
!     &                       NH4L2( c,r,l ) .Gt. 0.0       .And.
!     &                       NO3L1( c,r,l ) .Gt. 0.0       .And.
!     &                       NO3L2( c,r,l ) .Gt. 0.0       .And.
!     &                       CL1( c,r,l ) .Gt. 0.0       .And.
!     &                       CL2( c,r,l ) .Gt. 0.0       .And.
!     &                       pHs2( c,r,l ) .Gt. 0.0     ) Then
!                           If ( Index( Beld_Names( l ), '_ir' ) .Gt. 0 ) Then
!                              frac_ir( c,r ) = frac_ir( c,r ) + Beld_ag(c,r,l )
!                           End If
!                           Tot_Ag        = Tot_Ag + Beld_ag( c,r,l )
!                           NH4( c,r ) = NH4( c,r ) + (NH4L1( c,r,l )
!     &                                     * Beld_ag( c,r,l ) )
!     &                                     + (NH4L2( c,r,l ) 
!     &                                      * Beld_ag(c,r,l ) )
!                           NO3( c,r ) = NO3( c,r ) + (NO3L1( c,r,l )
!     &                                     * Beld_ag( c,r,l ) )
!     &                                     + (NO3L2( c,r,l )
!     &                                      * Beld_ag(c,r,l ) )
!                           Carbon( c,r ) = Carbon( c,r ) + (CL1( c,r,l )
!     &                                     * Beld_ag( c,r,l ) )
!     &                                     + (CL2( c,r,l )
!     &                                      * Beld_ag(c,r,l ) )
!                           LiableC( c,r ) = LiableC( c,r )+(0.01*Carbon(c,r))
C                           LiableC( c,r ) = LiableC( c,r )+Carbon(c,r)
C                           pHsl( c,r )    = pHsl( c,r ) + pHs2( c,r,l ) * Beld_ag(c,r,l )
C                        End If
C                     End If    
c                           gamma1( c,r ) = gamma1( c,r ) + convl1 * NH4ps1( c,r,l )
c     &                                   / pHfac1 * Beld_ag( c,r,l )
c                           MHp1( c,r )   = MHp1( c,r ) + Beld_ag( c,r,l) * pHfac1
c                           gamma2( c,r ) = gamma2( c,r ) + convl2 *NH4ps2( c,r,l )
c     &                                   / pHfac2 * Beld_ag( c,r,l )
c                           MHp2( c,r )   = MHp2( c,r ) + Beld_ag( c,r,l) * pHfac2
c                           If ( .Not. IsNaN( F_rate1( c,r,l ) ) .And.
c     &                                       F_rate1( c,r,l ) .Gt. 0.0 )
cThen
! Surface applied fertlizer
c                              fagam1( c,r ) = fagam1( c,r ) + F_rate1(
c c,r,l ) * Beld_ag( c,r,l )
c     &                                      * convl1 / pHfac1
!                  End Do ! e2c_cats
!                     If ( Tot_Ag .ge. 1.0e-6 ) Then  ! ~ 1.5 ha per grid cell
!                        NH4( c,r )    = NH4( c,r ) / Tot_Ag
!                        NO3( c,r )    = NO3( c,r ) / Tot_Ag
!                        Carbon( c,r ) = Carbon( c,r ) / Tot_Ag
!                        pHsl( c,r )   = pHsl( c,r ) / Tot_Ag
!                     Else
!                        NH4( c,r )    = 4.5
!                        NO3( c,r )    = 6.06
!                        Carbon( c,r ) = 203.91
!                        Carbon( c,r ) = 0.72 ! median EPIC value
!                        pHsl( c,r )   = 7.0
!                     End If
               End Do ! c
            End Do ! r
         End If ! INIT_MEDC_1

         Return
!------------------------------------------------------------------------------
! Error handling section
!------------------------------------------------------------------------------
1001     Continue
         Call M3exit( pname, jdate, jtime, xmsg, xstat1 )

C-------------------------------------------------------------------------------
C Format statements.
C-------------------------------------------------------------------------------

9001     Format( 'Failure reading ', a, 1x, 'from ', a )

         Return

         End Subroutine Init_CNnonAgcycle

!------------------------------------------------------------------------------
! Subroutine to get the N2O NO flux from nitrification denitrification
!------------------------------------------------------------------------------

C      CONTAINS
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C      SUBROUTINE 
      Subroutine Get_CNnonAgFlux( r, c, PULSE, THETA,
     &                         NITNOx,NITN2O, DENITNO, DENITN2O, 
     &                         NITNO, RNOTON2O, RDENN2TON2O, 
     &                         TSTEP, jdate, jtime, 
     &                         F_HONO, F_NO, F_N2O, NTR, DENTR )
      USE GRID_CONF           ! horizontal & vertical domain specifications
!      USE BDSNP_MOD, ONLY: PULSE ! Pulsing term from BDSNP
      USE BIOG_EMIS, ONLY: NSEF ! beis NSEF=number species, NO is last
      USE ASX_DATA_MOD
!      USE ABFLUX_MOD
      USE LSM_MOD
      USE UTILIO_DEFN
      USE CANOPY_NOX_MOD
      IMPLICIT NONE
        
C Includes:

C Arguments:
      INTEGER, INTENT( IN )  :: JDATE             ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME             ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: TSTEP( 3 )        ! time step vector (HHMMSS)
C      INTEGER, INTENT( IN ) :: NC      ! no. columns
C      INTEGER, INTENT( IN ) :: NR      ! no. rows
      Integer, Intent( IN )  :: r  ! no. of rows
      Integer, Intent( IN )  :: c  ! no. of columns
      REAL,    INTENT( IN )  :: THETA              ! water filled pore space
      Real,    INTENT( IN )  :: PULSE 
      Integer                   j ! counter
C      Integer, Intent( IN )  :: l ! species index
!      Character( 16 ), Parameter :: PNAME = 'Init_CNnonAgcycle'
!      Character( 96 )            :: XMSG = 'High NO variables '  
      
      
C     These are arrays 
c       REAL,    INTENT(IN)  :: LiableC ( c, r, : )
c       REAL,    INTENT(IN)  :: NO3 ( c, r, : )  
c       REAL,    INTENT(IN)  :: NH4 ( c, r, : )
       REAL,    INTENT(OUT)  :: RNOTON2O !ratio of NOx to N2O
       REAL,    INTENT(OUT)  :: NITN2O ! nitrifcn N2O 
       REAL,    INTENT(OUT)  :: RDENN2TON2O !ratio of N2 to N2O in denitrification
       REAL,    INTENT(OUT)  :: DENITN2O ! dintrification N2O 
       REAL,    INTENT(OUT)  :: DENITNO 
       REAL,    INTENT(OUT)  :: NITNOx 
       REAL,    INTENT(OUT)  :: NITNO
       REAL,    INTENT( OUT ) :: F_HONO
       REAL,    INTENT( OUT ) :: F_NO ! nitrifcation and denitrification
       REAL,    INTENT( OUT ) :: F_N2O ! nitrifcation and denitrification
       REAL,    INTENT( OUT ) :: DENTR 
       REAL,    INTENT( OUT ) :: NTR 
!-----------------------------------------------------------------------------

! Algorithm adapted from Huang and Gerber 2015, DAYcent (Del Grosso et
! al, 2000 and Parton et al., 2001) 
      !Soil diffusivity at field capacity
          REAL  :: KDENT
          REAL  :: dt


         Real    :: fTg    ! nitrification temperature factor
         Real    :: fSWg   ! nitrification Soil Water factor
         Real    :: fpHg   ! nitrification pH factor
         Real    :: Kn     ! nitrification rate 1/s
         Real    :: Kvs    ! Air-soil exchange rate for aqueous NH4+
         Real    :: kvg    ! Air-soil exchange rate for gas phase NH3
         Real    :: MNH3   ! molar atmospheric NH3 conc.
         Real    :: MNHx   ! molar soil water NH4+ + NH3 conc.
         Real    :: wg25   ! wilting point +0.25*(field capacity-wilting point)
!         Real    :: pHsl   ! Soil pH
         Real    :: ag_tot ! total
         Integer :: i   ! loop counter
         Real( 8 )         :: dp
         Real( 8 )         :: WFPS
         Real( 8 )         :: fWFPS
         Real( 8 )         :: fNO3toC   
         Real( 8 )         :: Dr      ! relative gas diffusitivity in soil comapred to air
      ! Declare local constant Pi
!         REAL, PARAMETER :: Pi = 3.1415927 

         Real( 8 )   :: k
         Real( 8 )   :: fWFPSDEN
         Real( 8 )   :: fTDEN
         Real( 8 )   :: fNO3D
         Real( 8 )   :: fSWC
         Real( 8 )   :: fEaT
      ! New soil biomes based on Ostwald et al., 2013
      INTEGER, PARAMETER :: OSW_NSOIL= 17  !Oswald et al, 2013: 17 biome type
      INTEGER, PARAMETER :: NSOIL    = 24  !USGS 24 LU/biome type  
      INTEGER          SOILCAT            ! soil category    
      Integer, Save      :: logdev      
! HONO:NO ratio for each of the 17 soil biomes [in fraction] FigS1
! Oswald et al., 2013
!      REAL*8,  PARAMETER :: A_HONO(OSW_NSOIL)        =                (/
!
!     &   0.11, 0.09, 0.00, 0.17, 0.27, 0.39, 0.43, 0.22, 0.02, 
!     &   0.51, 0.38, 0.85, 0.47, 0.60, 0.42, 0.45, 0.63     /)

C      REAL*8,  PARAMETER :: A_HONO = 0.429
      ! Oswald, 2013 A_HONO values, mapped to
      ! each of the 24 soil biomes [Zhang et al., 2016 JGR, Atmosphere]
!*****************************************************************************************************************
!*****************************************************************************************************************
!*****************************************************************************************************************
! These need to be defined for the NLCD 40 land use types
!      REAL*8,  PARAMETER :: A_HONO(NSOIL)          =                (/
!     &   0.00, 0.00, 0.00, 0.48, 0.00, 0.48, 0.355, 0.00, 0.41,
!     &   0.00, 0.41, 0.00, 0.22, 0.41, 0.13, 0.09, 0.11, 0.085,
!     &   0.085, 0.11, 0.09, 0.435, 0.00, 0.435     /)
      REAL*8,  PARAMETER :: A_HONO(40)        =                (/
     &   0.085, 0.09, 0.085, 0.11, 0.13, 0.355, 0.41, 0.41, 0.41,
     &   0.22, 0.00, 0.429, 0.00, 0.435, 0.00, 0.48, 0.00, 0.48,
     &   0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.0, 0.0, 
     &   0.09, 0.085, 0.13, 0.41, 0.41, 0.22, 0.41, 0.22, 0.22, 
     &   0.0, 0.0, 0.00, 0.00     /)
 !*****************************************************************************************************************
 !*****************************************************************************************************************
 !*****************************************************************************************************************
	  ! These need to be defined for the NLCD 40 land use types   
      INTEGER, PARAMETER :: MAXSTYPES = 11
C Saturation values for 11 soil types from pxpbl.F  (MCIP PX version)
C Pleim-Xiu Land-Surface and PBL Model (PX-LSM)
C See Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.
      REAL :: SATURATION( MAXSTYPES ) =
     &                  (/ 0.395, 0.410, 0.435, 0.485,
     &                     0.451, 0.420, 0.477, 0.476,
     &                     0.426, 0.482, 0.482 /)

         logdev =  init3()
     
      dt = FLOAT( TIME2SEC( TSTEP( 2 ) ) )

!      Write(logdev,*) 'dwat ', dwat, 'wsat ', GRID_DATA%WSAT( c,r )
!      Write(logdev,*) 'wfc ', GRID_DATA%WFC( c,r ), 'bslp ', GRID_DATA%BSLP( c,r )
! soil diffusitivity at field capacity in cm2/s in Del Grosso et al 2000
      dp  = dwat * GRID_DATA%WSAT( c,r )**2
     &       * ( 1.0 - GRID_DATA%WFC( c,r ) / GRID_DATA%WSAT( c,r ) ) 
     &       **( 2.0 + 3.0 / GRID_DATA%BSLP( c,r ) )



!******************************************* Nitrification Rate****************************************************
! Estimate the soil nitrification rate following Reddy et al 1979 starting with
! the temperature parameter
         fTg = max( 0.041 * ( MET_DATA%Tempg( C,R ) - 278.15 ), 0.0 )
 
! Estimate the soil water parameter
         wg25 = GRID_DATA%WWLT( c,r ) + 0.25 * ( GRID_DATA%WFC( c,r ) - GRID_DATA%WWLT( c,r ) )
         If ( Met_Data%SOIM1( c,r ) .Le. GRID_DATA%WWLT( c,r ) ) fSWg = 0.1
         If ( Met_Data%SOIM1( c,r ) .Lt. wg25 .And. Met_Data%SOIM1( c,r ) .Gt. GRID_DATA%WWLT( c,r ) ) Then
            fSWg = max( 0.1, 0.1 + 0.9 * Sqrt( ( Met_Data%SOIM1( c,r ) - GRID_DATA%WWLT( c,r ) ) /
     &                ( GRID_DATA%WFC( c,r ) - GRID_DATA%WWLT( c,r ) ) ), ( Met_Data%SOIM1( c,r ) - GRID_DATA%WWLT( c,r ) ) /
     &                ( 0.25 * ( GRID_DATA%WFC( c,r ) - GRID_DATA%WWLT( c,r ) ) ) )
         End If
         If ( Met_Data%SOIM1( c,r ) .Ge. wg25 .And. Met_Data%SOIM1( c,r ) .Lt. GRID_DATA%WFC( c,r ) ) fSWg = 1.0

         If ( Met_Data%SOIM1( c,r ) .Ge. GRID_DATA%WFC( c,r ) ) Then
            fSWg = max( 0.1, 1.0 - ( Met_Data%SOIM1( c,r ) - GRID_DATA%WFC( c,r ) ) / 
     &            ( GRID_DATA%WSAT( c,r )-GRID_DATA%WFC( c,r ) ) )
         End If
! Estimate the pH factor
!         Write(Logdev,*) 'R: ', r, 'C: ', c
!         Write(Logdev,*) 'R pHsl: ', size(pHsl,2), 'C pHsl: ', size(pHsl,1)
         If ( pHsl( c,r ) .Lt. 7.0 ) fpHg = 0.307 * pHsl( c,r ) - 1.269
         If ( pHsl( c,r ) .Ge. 7.0 .And. pHsl( c,r ) .Lt. 7.4 ) fpHg = 1.0
         If ( pHsl( c,r ) .Ge. 7.4) fpHg = 5.367 - 0.599 * pHsl( c,r )

!         Write(logdev,*) 'fTg ', fTg, 'fSWg ', fSWg, 'fpHg ', fpHg,'pH', pHsl(c,r)

         Kn = min(0.69,  fTg * fSWg * fpHg ) / 24.0 / 3600.0  ! Kn is in 1/d in EPIC convert to 1/s
        
         NTR = NH4( c,r ) * ( 1.0 - EXP(-kn*dt) ) /dt !/ 24.0 / 3600.0  !/dt Average Nitrified NH4 kg/ha/s
         NH4( c,r ) = NH4( c,r ) * EXP(-kn*dt)                  ! updated NH4 pool
!         NO3( c,r ) = NO3( c,r ) + NH4( c,r ) * ( 1.0 - EXP(-kn*dt) )
         NO3( c,r ) = NH4( c,r ) * ( 1.0 - EXP(-kn*dt) )
!********************************************* Denitrification-Nitrfication fluxes NO N2O ********************************************
!Fractional water filled pore space
         WFPS = (MET_DATA%SOIM1( c,r ) - GRID_DATA%WRES( c,r ))/ 
     &               (GRID_DATA%WSAT( c,r )-GRID_DATA%WRES( c,r ))
         WFPS = min(1.0, max(WFPS,0.0))
!Relative gas diffusitivity in soil w.r.t. air (Huang and Gerber, 2015)
!         Dr  = 0.209 * ((1.0-WFPS)**(4.0/3.0)) 
         Dr  = dwat * GRID_DATA%WSAT( c,r )**2
     &       * ( max(1.0 - MET_DATA%SOIM1( c,r ) / GRID_DATA%WSAT( c,r ),0.0) ) 
     &       **( 2.0 + 3.0 / GRID_DATA%BSLP( c,r ) )
!         Write(logdev,*) 'Dr: ', Dr
!NO:N2Oratio Parton et al., 2001 Del Grosso et al., 2000 same as DayCENT model       
         RNOTON2O = 15.2 + ((35.5*ATAN(0.68*Pi*((10.0*Dr)-1.86)))/Pi)
!         Write(logdev,*) 'RNOTON2O: ', RNOTON2O

!Nitrification N2O flux   
         NITN2O = 0.02 * NTR * XCELL_GD * YCELL_GD / 100.0 / 100.0 * 1.0e3 * 3600.0 ! from CMAQ ABFLUX , Parton et al, 2001 kg/ha/s to g N/hr
        
!Parton et al. 2001 used YL pulsing, here BDSNP module pulsing is used
!Nitrification NO flux        
         NITNOx = RNOTON2O * NITN2O * PULSE ! Parton et al, 2001
!         Write(logdev,*) 'NITNOx: ', NITNOx


!soil texture dependent parameter (Del Grosso et al., 2000)
         k = max ( 1.7, (38.4 - (350 * dp )) )  
!-----Denitification N2:N2O ratio Calculation------------------------------!
!         Write(logdev,*) 'NO3', NO3(c,r), 'LiableC',LiableC( c,r ), 'k', k
         if(LiableC( c,r ) .gt. 0.0 ) Then
            fNO3toC = max(0.16 * k, k * exp(-0.8*(NO3( c,r )/LiableC( c,r ))))   !NO3:C availability function
         else 
            fNO3toC = 0.16 * k
         end if
        
         fWFPS   = max ( 0.1, (0.015* WFPS* 100-(0.32)))  !WFPS factor
         

         RDENN2TON2O = fNO3toC * fWFPS   
!-----------Denitrification rate for NO N2O flux calulation--------------------------------!

         fNO3D = 1.15 * (NO3( c,r )**0.57) ! del grosso et al 2000 , NO3 in microg N per g soil
           !fCDEN = 0.1 * (LiableC ^ 1.3)
!         fWFPSDEN = 1.56/ (12.0**(16.0/(12.0**(2.01 * WFPS )))) !WFPS funcn for Denitr rate calculation 
! Parton et al 1996 WFPS function used by del Grosso et al 2000 for medium texture soil (should be more applicable than sand commented out above and textural functions should be added)
! additionally this funciton should be bounded between 0 and 1
         fWFPSDEN = min(1.0, 4.82/ (14.0**(16.0/(12.0**(1.39 * WFPS ))))) !WFPS funcn for Denitr rate calculation 
!         Write(logdev,*) 'fWFPSDEN: ', fWFPSDEN
C         fTDEN    = min(1.0,EXP(308.56*(1.0/68.02-1.0/(MET_DATA%SOIT1( c,r )-227.13)))) !Temp funcn for Denitr rate calculation

         fTDEN    = max(0.0,(MET_DATA%SOIT1( c,r )-273.15)/
     &          (MET_DATA%SOIT1( c,r )-273.15+EXP(5.059-0.2504*
     &          (MET_DATA%SOIT1( c,r )-273.15))))

!         Write(logdev,*) 'fTDEN: ', fTDEN

! Denitrification rate in kg N/(m2 year) Huang and Gerber Biogeosci 2015
! doi:10.5194/bg-12-6405-2015

!         KDENT = fTDEN * fWFPSDEN * 8750.0 * (LiableC( c,r )*NO3( c,r
!         ))/((LiableC( c,r )+0.0017*10000.0)*

! use the EPIC daily denitrification rate

         KDENT = fTDEN * fWFPSDEN * 1.4 * ( LiableC( c,r ) *
     &          NO3( c,r ) ) / ( (LiableC( c,r ) + ((0.0017 * 10000.0
     &          ))) * (NO3( c,r ) + ((0.0083*10000.0))) )

!         KDENT = fTDEN * fWFPSDEN * 1.4 * ( LiableC( c,r ) *
!     &          NO3( c,r ) ) / ( (LiableC( c,r ) +
!     &          ((0.0017 * 10000.0 * 24.0 * 3600.0)/dt)) *
!     &          (NO3( c,r ) + ((0.0083*10000.0 * 24.0 * 3600.0)/dt)) )

!         KDENT = min(0.69,KDENT)
 
!         Write(logdev,*) 'fTDEN: ', fTDEN
! Denitrification rate in kg N/(m2 year) Huang and Gerber Biogeosci 2015 doi:10.5194/bg-12-6405-2015
!         KDENT = fTDEN * fWFPSDEN * 8750.0 * (LiableC( c,r )*NO3( c,r ))/((LiableC( c,r )+0.0017*10000.0)*
! use the EPIC daily denitrification rate
C         KDENT = fTDEN * fWFPSDEN * 1.4 * ( LiableC( c,r ) * 
C     &          NO3( c,r ) ) / ( (LiableC( c,r ) +
C     &          ((0.0017 * 10000.0 * 24.0 * 3600.0)/dt)) *
C     &          (NO3( c,r ) + ((0.0083*10000.0 * 24.0 * 3600.0)/dt)) )  
!         Write(logdev,*) 'KDENT: ', KDENT
! convert to 1/s assume 365 days in a year 
!         KDENT = KDENT/365.0/24.0/3600.0
! convert to 1/s from 1/d 
         KDENT = min(0.01,KDENT)/24.0/3600.0
!         Write(logdev,*) 'KDENT: ', KDENT
! Integrate for an exponential decay assuming that NO3 production on the daily time scale is neglegible.
!         write( logdev, *) 'KDENT', KDENT, 'dt ',dt 
         if(KDENT .Gt. 0.0 ) Then
            DENTR =  NO3( c,r ) * (1.0 - EXP(-KDENT * dt) ) /dt !/ 24.0 / 3600.0 !/dt average 1 per s
            NO3( c,r ) = NTR/KDENT + (NO3( c,r )-NTR/KDENT) * EXP(-KDENT * dt)  
         else 
            DENTR = 0.0
         end if
! Hauer and Gerber 2015 , kg N per m2 per yr .0017 and 0.0083 in kg N
! per m2

!NO N2O fluxes from Denitrification
         DENITN2O = DENTR/( 1.0 + RDENN2TON2O) * XCELL_GD * YCELL_GD / 100.0 / 100.0 * 1.0e3 * 3600.0 !Denitrification N2O flux kg N/ha/s to g N / hr
         DENITNO  = RNOTON2O * DENITN2O      !Denitrification NO flux g N / hour
!         Write(logdev,*) 'DENITNO: ', DENITNO

! *************************************** fraction of HONO emissions as a function of fractional soil water content from BDSNP_MOD_EPIC.F
c       SOILCAT = INT( Grid_Data%SLTYP( C,R ) )
c       Met_Data%SOIT1(C,R)  

!*******************************************************
! HONO SWC (THETA) dependency         
!*******************************************************
! Biome 24 LU categories loop
!      Do j=1, NSOIL
      fSWC = 0.0
      Do j=1, 40 !n_lufrac
       IF ( WFPS .LE. 0.1) THEN  
          fSWC = fSWC + (A_HONO(j) * WFPS)/0.1*Grid_Data%LUFRAC( C,R,J)  !Assuming linear increase till 10% SWC
        ELSEIF ( WFPS .LE. 0.40 ) THEN
          fSWC = fSWC + A_HONO(j) * (0.4-WFPS)/(0.4-0.1) *Grid_Data%LUFRAC( C,R,J)
        ELSE
          fSWC = 0.0
       ENDIF
      End Do
!      fEaT = exp((80.0/0.00831447)*((1.0/298.15)-(1.0/Met_Data%SOIT1(C,R))))
! New NItrification HONO and NO
       F_HONO = fSWC * NITNOx
       NITNO = NITNOx - F_HONO
       F_NO = NITNO + DENITNO
!       F_NO = 0.0 !NITNO
       F_N2O = NITN2O + DENITN2O
!       F_N2O = 0.0 !NITN2O
!      Write(logdev,*) 'fSWC: ', fSWC

       if( IsNaN( F_NO ) ) Then
          Write(logdev,*) 'NITNO:       ', NITNO
          Write(logdev,*) 'DENITN2O:    ', DENITN2O
          Write(logdev,*) 'RNOTON2O:    ', RNOTON2O
          Write(logdev,*) 'RDENN2TON2O: ', RDENN2TON2O
          Write(logdev,*) 'DENTR:       ', DENTR
          Write(logdev,*) 'NTR:         ', NTR
       End If
       
!       if( F_NO .gt. 2.0e3 ) then
!       write(logdev,*) a bunch of variable used to estimate the NO flux
C          Write(logdev,*) 'NITNO:       ', NITNO
C          Write(logdev,*) 'DENITN2O:    ', DENITN2O
C          Write(logdev,*) 'RNOTON2O:    ', RNOTON2O
C          Write(logdev,*) 'RDENN2TON2O: ', RDENN2TON2O
C          Write(logdev,*) 'DENTR:       ', DENTR
C          Write(logdev,*) 'NTR:         ', NTR
C          Write(logdev,*) 'F_NO:         ', F_NO
!          call m3exit()
!          Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
!       end if

      Return
!------------------------------------------------------------------!
!NO emissions as in BDSNP/EPIC Algorithm (BDSNP_MOD.F)
C          NOPOL( C,R ) = SOILNOX * CELLAREA * 3600.0 * 10.0**-9 ![ngN/m2/s] * m2 * s/hr * g/ng
      END Subroutine Get_CNnonAgFlux !Get_NFlux

         Logical Function IsNaN( a ) ! required for Portland Group compiler (pgi)
            Real :: a
            If ( a .Eq. a ) Then   ! requires -Kieee flag for pgi
!              write( *,* ) '==IsNaN false: ', a
               IsNaN = .false.
            Else
!              write( *,* ) '==IsNaN true: ', a
               IsNaN = .true.
            End If
            Return
         End Function IsNaN  ! error, if pgf90
!        End  ! error, if ifort


       END MODULE CNNONAG_CYCLE_MOD


