!-----Based on ABFLUX.F in CCTM module----!
      MODULE N_CYCLE_MOD
      IMPLICIT NONE
C      REAL,    ALLOCATABLE, SAVE :: NDEPRATE  ( :,: )  ! "ng N m-2 s-1"
C      LOGICAL, SAVE     :: BDSNP
C      LOGICAL, SAVE     :: EPIC
       LOGICAL, SAVE     :: NCYCLE
! shared variables used in module and subroutines
      Real, Save, Allocatable :: frac_ir( :,: ) ! irrigated fraction of ag
c      Real, Save, Allocatable:: fagam1 ( :,: ) ! due to fertilizer app
c      Real, Save, Allocatable :: fagam2 ( :,: ) ! due to fertilizer app
      Real, Save, Allocatable :: NH4L1 ( :,:,: ) ! Initial Soil L1_NH4
      Real, Save, Allocatable :: NH4L2 ( :,:,: ) ! Initial Soil L2_NH4
      Real, Save, Allocatable :: NH4 ( :,: ) ! Total soil NH4 all crops
      Real, Save, Allocatable :: NO3L1 ( :,:,: ) ! Initial Soil L1_NO3
      Real, Save, Allocatable :: NO3L2 ( :,:,: ) ! Initial Soil L2_NO3
      Real, Save, Allocatable :: NO3 ( :,: ) ! Total soil NO3 all crops
      Real, Save, Allocatable :: pHsl ( :,: ) ! Area weighted soil pH
      Real, Save, Allocatable :: CL1 ( :,:,: ) ! Initial Soil L1_C
      Real, Save, Allocatable :: CL2 ( :,:,: ) ! Initial Soil L2_C
      Real, Save, Allocatable :: Carbon ( :,: ) ! daily soil C respiration flux all crops
      Real, Save, Allocatable :: LiableC ( :, : ) ! Total Liable C 
      Real, Save, Allocatable :: pHs2   ( :,:,: )
!      Real, Save, Allocatable :: pHs2   ( :,:,: ) 
!      REAL,    ALLOCATABLE, SAVE :: DRYPERIOD( :,: )  ! Will determine pulse, hours
!      REAL,    ALLOCATABLE, SAVE :: PFACTOR  ( :,: )  ! current pulse factor
!      REAL,    ALLOCATABLE, SAVE :: SOILMPREV( :,: )  ! soil moisture previous tstep [m3/m3] (PX)
!      INTEGER, ALLOCATABLE, Save :: LANDFRAC( :,: )
!      CHARACTER( 16 ), SAVE :: LANDFRACFILE = 'LANDFRACFILE' !biome type 
C      Real, Save,              Private :: C_gam           ! Canadian fertilizer facter
c      Real, Parameter,         Private :: maxgam   = 2.0e5 ! maximum soil gamm. It is assumed that any excess NH4 would from salts
c      Real, Parameter,         Private :: natgam   = 20.0  ! Background soil gamma


      Contains
        Subroutine Init_Ncycle( jdate, jtime )
       
         Use HGRD_DEFN           ! horizontal grid specifications
C        USE GRID_CONF           ! horizontal & vertical domain specifications
         Use UTILIO_DEFN
C         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2

         Implicit None
! Includes
         Include SUBST_CONST     ! constants
         Include SUBST_FILES_ID  ! file name parameters

! Local Variables

         Integer, Intent( In )  :: jdate
         Integer, Intent( In )  :: jtime
         Integer                :: c,r,l,k
         Integer, Parameter :: e2c_cats = 42   ! number of crop
catigories
         Integer            :: gxoff, gyoff    ! global origin offset from file
         integer, save      :: strtcol, endcol, strtrow, endrow
         Integer, Save      :: logdev      

c         Real, Save, Allocatable :: F_rate1 ( :,:,: ) ! fertlizer application to layer 1
c         Real, Save, Allocatable :: F_rate2 ( :,:,: ) ! fertlizer application to layer 2

         Real, Save, Allocatable :: Beld_ag ( :,:,: )
         Real                    :: Tot_Ag          ! total ag in the grid cell
C         Real, Parameter :: convl1 = 7.142857e-04   ! ha/m**2 * mol/g N * 1/z_soil_l1
C         Real, Parameter :: convl2 = 1.428571e-04   ! ha/m**2 * mol/g N * 1/z_soil_l2
C         Real            :: pHfac1
C         Real            :: pHfac2

         Character( 16 ), Parameter :: pname = 'Init_Ncycle'
         Character( 16 )            :: vname
         Character( 96 )            :: xmsg = ' '
         Character( 20 ), Save      :: Beld_Names( e2c_cats )
C Some compilers do not pad with blank characters in data initialization
C                          '12345678901234567890'
         Data Beld_Names / 'Hay                 ',  !  1
     &                     'Hay_ir              ',  !  2
     &                     'Alfalfa             ',  !  3
     &                     'Alfalfa_ir          ',  !  4
     &                     'Other_Grass         ',  !  5
     &                     'Other_Grass_ir      ',  !  6
     &                     'Barley              ',  !  7
     &                     'Barley_ir           ',  !  8
     &                     'BeansEdible         ',  !  9
     &                     'BeansEdible_ir      ',  ! 10
     &                     'CornGrain           ',  ! 11
     &                     'CornGrain_ir        ',  ! 12
     &                     'CornSilage          ',  ! 13
     &                     'CornSilage_ir       ',  ! 14
     &                     'Cotton              ',  ! 15
     &                     'Cotton_ir           ',  ! 16
     &                     'Oats                ',  ! 17
     &                     'Oats_ir             ',  ! 18
     &                     'Peanuts             ',  ! 19
     &                     'Peanuts_ir          ',  ! 20
     &                     'Potatoes            ',  ! 21
     &                     'Potatoes_ir         ',  ! 22
     &                     'Rice                ',  ! 23
     &                     'Rice_ir             ',  ! 24
     &                     'Rye                 ',  ! 25
     &                     'Rye_ir              ',  ! 26
     &                     'SorghumGrain        ',  ! 27
     &                     'SorghumGrain_ir     ',  ! 28
     &                     'SorghumSilage       ',  ! 29
     &                     'SorghumSilage_ir    ',  ! 30
     &                     'Soybeans            ',  ! 31
     &                     'Soybeans_ir         ',  ! 32
     &                     'Wheat_Spring        ',  ! 33
     &                     'Wheat_Spring_ir     ',  ! 34
     &                     'Wheat_Winter        ',  ! 35
     &                     'Wheat_Winter_ir     ',  ! 36
     &                     'Other_Crop          ',  ! 37
     &                     'Other_Crop_ir       ',  ! 38
     &                     'Canola              ',  ! 39
     &                     'Canola_ir           ',  ! 40
     &                     'Beans               ',  ! 41
     &                     'Beans_ir            ' / ! 42
         logdev =  init3()
! Find the Canadian fertilizer factor based off of Sheppard et al 2010
! Canadian J. Soil Sci. &
! Zhang et al. 2010 JGR
c         Select Case( jdate )
c            Case(  60:90 )
c               C_gam = 811.5
c            Case(  91:120 )
c               C_gam = 3447.3
c            Case( 121:151 )
c               C_gam = 8702.8
c            Case( 152:181 )
c               C_gam = 1269.3
c           Case( 182:212 )
c               C_gam = 667.1
c            Case( 213:243 )
c               C_gam = 704.2
c            Case( 244:273 )
c               C_gam = 811.5
c            Case( 274:304 )
c               C_gam = 1376.7
c            Case( 305:334 )
c              C_gam = 1079.6
c            Case Default
c               C_gam = 630.0
c         End Select

! time in the files is not the same
C         If ( .Not. Open3( E2C_SOIL, fsread3, pname ) ) Then
C           xmsg = 'Could not open '// E2C_SOIL // ' file'
C           Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
C         End If

         Call Subhfile ( E2C_SOIL, gxoff, gyoff, strtcol, endcol, strtrow, endrow )

         If ( .Not. Allocated ( pHs2 ) ) Then
            Allocate ( pHs2 ( my_ncols,my_nrows,e2c_cats ) )
         End If

         vname = 'L2_PH'
         If ( .Not. Xtract3 ( E2C_SOIL, vname, 1, e2c_cats, strtrow, endrow,
     &                        strtcol, endcol, jdate, 0, pHs2 ) ) Then
            Write( xmsg,9001 ) vname, E2C_SOIL
            Go To 1001
         End If
!         If ( .Not. Allocated ( pHs2 ) ) Then
c            Allocate ( pHs2 ( my_ncols,my_nrows,e2c_cats ) )
C         End If

C         vname = 'L2_PH'
c         If ( .Not. Xtract3 ( E2C_SOIL, vname, 1, e2c_cats, strtrow, endrow,
C     &                        strtcol, endcol, jdate, 0, pHs2 ) ) Then
C            Write( xmsg,9001 ) vname, E2C_SOIL
C            Go To 1001
C         End If
! get BELD4 land use types time independent files.
         If ( .Not. Open3( BELD4_LU, fsread3, pname ) ) Then
           xmsg = 'Could not open '// BELD4_LU // ' file'
           Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
         End If
         If ( .Not. Allocated ( Beld_ag ) ) Then
            Allocate ( Beld_ag ( my_ncols,my_nrows,e2c_cats ) )
         End If
         Do k = 1, e2c_cats
            vname = BELD_Names(k)
            If ( .Not. Interpx ( BELD4_LU, vname, pname, strtcol, endcol,
     &                           strtrow, endrow, 1, 1, jdate, jtime,
     &                           Beld_ag( :,:,k ) ) ) Then
               Write( xmsg,9001 ) vname, BELD4_LU
               Go To 1001
            End If
         End Do
         Beld_ag = 0.01 * Beld_ag   ! convert to fraction
    


c             IF ( .NOT. XTRACT3( LANDFRACFILE, 'LANDFRAC',
c     & 1,1, strtrow, endrow, strtcol, endcol,
c     & 0, 0, LANDFRAC ) ) THEN
c         MESG = 'Could not open LANDFRAC file'
c         CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
c      END IF
C      Write(LOGDEV,*) 'about to extract lfrac, NCOLS,NROWS', NCOLS,
C      NROWS
c      IF ( .NOT. XTRACT3( LANDFRACFILE, 'LANDFRAC',
c     & 1,1, strtrow, endrow, strtcol, endcol,
c     & 0, 0, LANDFRAC ) ) THEN
c       MESG = 'Could not read LANDFRAC from LANDFRACFILE'
c       CALL M3EXIT( pname, jdate, jtime, MESG, XSTAT1 )
c      END IF    


! Allocate variable needed for soil processes, nitr-denitr and fertilization
c         If ( .Not. Allocated ( gamma1 ) ) Then
c            Allocate ( gamma1 ( my_ncols,my_nrows ) )
c         End If
c         gamma1 = 0.0
c         If ( .Not. Allocated ( gamma2 ) ) Then
c            Allocate ( gamma2 ( my_ncols,my_nrows ) )
c         End If
c         gamma2 = 0.0
c         If ( .Not. Allocated ( fagam1 ) ) Then
c            Allocate ( fagam1 ( my_ncols,my_nrows ) )
c         End If
c         fagam1 = 0.0
c         If ( .Not. Allocated ( fagam2 ) ) Then
c            Allocate ( fagam2 ( my_ncols,my_nrows ) )
c         End If
c         fagam2 = 0.0
c         If ( .Not. Allocated ( MHp1 ) ) Then
c            Allocate ( MHp1 ( my_ncols,my_nrows ) )
c         End If
c         MHp1 = 0.0
c         If ( .Not. Allocated ( MHp2 ) ) Then
c            Allocate ( MHp2 ( my_ncols,my_nrows ) )
c         End If
c         MHp2 = 0.0

C         ALLOCATE( DRYPERIOD( my_ncols,my_nrows ), STAT=IOS )
C         CALL CHECKMEM( IOS, 'PTYPE', pname ) 
!          If ( .Not. Allocated ( DRYPERIOD ) ) Then
!            Allocate ( DRYPERIOD ( my_ncols,my_nrows ) )
!         End If
!         DRYPERIOD = 0.0
c         ALLOCATE( PFACTOR( my_ncols,my_nrows ), STAT=IOS )
C         CALL CHECKMEM( IOS, 'PTYPE', pname )
!          If ( .Not. Allocated ( PFACTOR ) ) Then
!            Allocate ( PFACTOR ( my_ncols,my_nrows ) )
!         End If
!         PFACTOR = 0.0         
         
c         ALLOCATE( SOILMPREV( NCOLS,NROWS ), STAT=IOS )
c        CALL CHECKMEM( IOS, 'SOILMPREV', PNAME )
!         If ( .Not. Allocated ( SOILMPREV ) ) Then
!            Allocate ( SOILMPREV ( my_ncols,my_nrows ) )
!         End If
!         SOILMPREV = 0.0
c        ALLOCATE( LANDFRAC( NCOLS,NROWS ), STAT=IOS )^M
c         CALL CHECKMEM( IOS, 'LANDFRAC', PNAME )
!          If ( .Not. Allocated ( LANDFRAC ) ) Then
!            Allocate ( LANDFRAC ( my_ncols,my_nrows ) )
!         End If
c         SOILMPREV = 0.0
         
         If ( .Not. Allocated ( frac_ir ) ) Then
            Allocate ( frac_ir ( my_ncols,my_nrows ) )
         End If
         frac_ir = 0.0
         If ( .Not. Allocated ( NH4 ) ) Then
            Allocate ( NH4 ( my_ncols,my_nrows ) )
         End If
         NH4 = 0.0
         If ( .Not. Allocated ( NO3 ) ) Then
            Allocate ( NO3 ( my_ncols,my_nrows ) )
         End If
         NO3 = 0.0
         If ( .Not. Allocated ( Carbon ) ) Then
            Allocate ( Carbon ( my_ncols,my_nrows ) )
         End If
         Carbon = 0.0
         If ( .Not. Allocated ( LiableC ) ) Then
            Allocate ( LiableC ( my_ncols,my_nrows ) )
         End If
         LiableC = 0.0
         If ( .Not. Allocated ( pHsl ) ) Then
            Allocate ( pHsl ( my_ncols,my_nrows ) )
         End If
         pHsl = 0.0
C         If ( .Not. Allocated ( HONO ) ) Then
C            Allocate ( HONO ( my_ncols,my_nrows ) )
C         End If
C         HONO = 0.0
C         If ( .Not. Allocated ( NITNO ) ) Then
C            Allocate ( NITNO ( my_ncols,my_nrows ) )
C         End If
C         NITNO = 0.0
! get soil N pools NH4 NO3 and C and dates
! time in the files is not the same
c         If ( .Not. Open3( E2C_FERT, fsread3, pname ) ) Then
c           xmsg = 'Could not open '// E2C_FERT // ' file'
c           Call M3exit ( pname, 0, 0, xmsg, xstat1 )
c         End If
! get fertilizer from the previous month to estimate soil NH4+
! time in the files is not the same
         If ( .Not. Open3( INIT_MEDC_1, fsread3, pname ) ) Then
            Write(Logdev,*) 'Estimating soil NHx NO3 C from EPIC output'
            If ( .Not. Open3( E2C_FERT, fsread3, pname ) ) Then
               xmsg = 'Could not open '// E2C_FERT // ' file'
               Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
            End If
         If ( .Not. Allocated ( NH4L1 ) ) Then
            Allocate ( NH4L1 ( my_ncols,my_nrows,e2c_cats ) )
         End If
         NH4L1 = 0.0
         If ( .Not. Allocated ( NH4L2 ) ) Then
            Allocate ( NH4L2 ( my_ncols,my_nrows,e2c_cats ) )
         End If
         NH4L2 = 0.0
         If ( .Not. Allocated ( NO3L1 ) ) Then
            Allocate ( NO3L1 ( my_ncols,my_nrows,e2c_cats ) )
         End If
         NO3L1 = 0.0
         If ( .Not. Allocated ( NO3L2 ) ) Then
            Allocate ( NO3L2 ( my_ncols,my_nrows,e2c_cats ) )
         End If
         NO3L2 = 0.0
         If ( .Not. Allocated ( CL1 ) ) Then
            Allocate ( CL1 ( my_ncols,my_nrows,e2c_cats ) )
         End If
         CL1 = 0.0
         If ( .Not. Allocated ( CL2 ) ) Then
            Allocate ( CL2 ( my_ncols,my_nrows,e2c_cats ) )
         End If
         CL2 = 0.0
         vname = 'L1_NH3'
         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
     &                       strtcol, endcol, jdate, 0, NH4L1 ) ) Then
            Write( xmsg,9001 ) vname, E2C_FERT
            Go To 1001
         End If
         vname = 'L2_NH3'
         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
     &                       strtcol, endcol, jdate, 0, NH4L2 ) ) Then
            Write( xmsg,9001 ) vname, E2C_FERT
            Go To 1001
         End If
         vname = 'L1_NO3'
         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
     &                       strtcol, endcol, jdate, 0, NO3L1 ) ) Then
            Write( xmsg,9001 ) vname, E2C_FERT
            Go To 1001
         End If
         vname = 'L2_NO3'
         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
     &                       strtcol, endcol, jdate, 0, NO3L2 ) ) Then
            Write( xmsg,9001 ) vname, E2C_FERT
            Go To 1001
         End If
         vname = 'HMN'
         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
     &                       strtcol, endcol, jdate, 0, CL1 ) ) Then
            Write( xmsg,9001 ) vname, E2C_FERT
            Go To 1001
         End If
         vname = 'L2_C'
         If ( .Not. Xtract3 (E2C_FERT, vname, 1, e2c_cats, strtrow, endrow,
     &                       strtcol, endcol, jdate, 0, CL2 ) ) Then
            Write( xmsg,9001 ) vname, E2C_FERT
            Go To 1001
         End If
! parameters
            Do r = 1, my_nrows
               Do c = 1, my_ncols
                  Tot_Ag = 0.0
                  Do l = 1, e2c_cats
                     If( .Not. IsNaN( NH4L1( c,r,l ) ) .And.
     &                   .Not. IsNaN( NH4L2( c,r,l ) ) .And.
     &                   .Not. IsNan( NO3L1( c,r,l ) ) .And.
     &                   .Not. IsNan( NO3L2( c,r,l ) ) .And.
     &                   .Not. IsNan( CL1( c,r,l ) ) .And.
     &                   .Not. IsNan( CL2( c,r,l ) ) .And.
     &                   .Not. IsNan( pHs2( c,r,l ) ) .And.
     &                    Beld_ag( c,r,l ) .Gt. 0.0 ) Then
! convert units from kg/ha N to mol/l
                        If ( NH4L1( c,r,l ) .Gt. 0.0       .And.
     &                       NH4L2( c,r,l ) .Gt. 0.0       .And.
     &                       NO3L1( c,r,l ) .Gt. 0.0       .And.
     &                       NO3L2( c,r,l ) .Gt. 0.0       .And.
     &                       CL1( c,r,l ) .Gt. 0.0       .And.
     &                       CL2( c,r,l ) .Gt. 0.0       .And.
     &                       pHs2( c,r,l ) .Gt. 0.0     ) Then
                           If ( Index( Beld_Names( l ), '_ir' ) .Gt. 0 ) Then
                              frac_ir( c,r ) = frac_ir( c,r ) + Beld_ag(c,r,l )
                           End If
                           Tot_Ag        = Tot_Ag + Beld_ag( c,r,l )
                           NH4( c,r ) = NH4( c,r ) + (NH4L1( c,r,l )
     &                                     * Beld_ag( c,r,l ) )
     &                                     + (NH4L2( c,r,l ) 
     &                                      * Beld_ag(c,r,l ) )
                           NO3( c,r ) = NO3( c,r ) + (NO3L1( c,r,l )
     &                                     * Beld_ag( c,r,l ) )
     &                                     + (NO3L2( c,r,l )
     &                                      * Beld_ag(c,r,l ) )
                           Carbon( c,r ) = Carbon( c,r ) + (CL1( c,r,l )
     &                                     * Beld_ag( c,r,l ) )
!     &                                     + (CL2( c,r,l )
!     &                                      * Beld_ag(c,r,l ) )
!                           LiableC( c,r ) = LiableC( c,r )+(0.01*Carbon(c,r))
                           LiableC( c,r ) = LiableC( c,r )+Carbon(c,r)
C     &                                      * Beld_ag(c,r,l )
                           pHsl( c,r )    = pHsl( c,r ) + pHs2( c,r,l ) * Beld_ag(c,r,l )
                        End If
                     End If    
c                           gamma1( c,r ) = gamma1( c,r ) + convl1 * NH4ps1( c,r,l )
c     &                                   / pHfac1 * Beld_ag( c,r,l )
c                           MHp1( c,r )   = MHp1( c,r ) + Beld_ag( c,r,l) * pHfac1
c                           gamma2( c,r ) = gamma2( c,r ) + convl2 *NH4ps2( c,r,l )
c     &                                   / pHfac2 * Beld_ag( c,r,l )
c                           MHp2( c,r )   = MHp2( c,r ) + Beld_ag( c,r,l) * pHfac2
c                           If ( .Not. IsNaN( F_rate1( c,r,l ) ) .And.
c     &                                       F_rate1( c,r,l ) .Gt. 0.0 )
cThen
! Surface applied fertlizer
c                              fagam1( c,r ) = fagam1( c,r ) + F_rate1(
c c,r,l ) * Beld_ag( c,r,l )
c     &                                      * convl1 / pHfac1
                  End Do ! e2c_cats
                     If ( Tot_Ag .ge. 1.0e-6 ) Then  ! ~ 1.5 ha per grid cell
                        NH4( c,r )    = NH4( c,r ) / Tot_Ag
                        NO3( c,r )    = NO3( c,r ) / Tot_Ag
                        Carbon( c,r ) = Carbon( c,r ) / Tot_Ag
                        pHsl( c,r )   = pHsl( c,r ) / Tot_Ag
                     Else
                        NH4( c,r )    = 4.5
                        NO3( c,r )    = 6.06
!                        Carbon( c,r ) = 203.91
                        Carbon( c,r ) = 0.72 ! median EPIC value
                        pHsl( c,r )   = 7.0
                     End If
                End Do ! c
            End Do ! r         
         End If ! INIT_MEDC_1

         Return
!------------------------------------------------------------------------------
! Error handling section
!------------------------------------------------------------------------------
1001     Continue
         Call M3exit( pname, jdate, jtime, xmsg, xstat1 )

C-------------------------------------------------------------------------------
C Format statements.
C-------------------------------------------------------------------------------

9001     Format( 'Failure reading ', a, 1x, 'from ', a )

         Return

         End Subroutine Init_Ncycle

!------------------------------------------------------------------------------
! Subroutine to get the N2O NO flux from nitrification denitrification
!------------------------------------------------------------------------------

C      CONTAINS
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C      SUBROUTINE 
      Subroutine Get_NFlux( r, c, PULSE, THETA,
     &                         NITNOx,NITN2O, DENITNO, DENITN2O, 
     &                         NITNO, RNOTON2O, RDENN2TON2O, 
     &                         TSTEP, jdate, jtime, 
     &                         F_HONO, F_NO, F_N2O, NTR, DENTR )
      USE GRID_CONF           ! horizontal & vertical domain specifications
!      USE BDSNP_MOD, ONLY: PULSE ! Pulsing term from BDSNP
      USE BIOG_EMIS, ONLY: NSEF ! beis NSEF=number species, NO is last
      USE ASX_DATA_MOD
!      USE ABFLUX_MOD
      USE LSM_MOD
      USE UTILIO_DEFN
      USE CANOPY_NOX_MOD
      IMPLICIT NONE
        
C Includes:

C Arguments:
      INTEGER, INTENT( IN )  :: JDATE             ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME             ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: TSTEP( 3 )        ! time step vector (HHMMSS)
C      INTEGER, INTENT( IN ) :: NC      ! no. columns
C      INTEGER, INTENT( IN ) :: NR      ! no. rows
      Integer, Intent( IN )  :: r  ! no. of rows
      Integer, Intent( IN )  :: c  ! no. of columns
      REAL,    INTENT( IN )  :: THETA              ! water filled pore space
      Real,    INTENT( IN )  :: PULSE 
C      Integer, Intent( IN )  :: l ! species index
    
      
C     These are arrays 
c       REAL,    INTENT(IN)  :: LiableC ( c, r, : )
c       REAL,    INTENT(IN)  :: NO3 ( c, r, : )  
c       REAL,    INTENT(IN)  :: NH4 ( c, r, : )
       REAL,    INTENT(OUT)  :: RNOTON2O !ratio of NOx to N2O
       REAL,    INTENT(OUT)  :: NITN2O ! nitrifcn N2O 
       REAL,    INTENT(OUT)  :: RDENN2TON2O !ratio of N2 to N2O in denitrification
       REAL,    INTENT(OUT)  :: DENITN2O ! dintrification N2O 
       REAL,    INTENT(OUT)  :: DENITNO 
       REAL,    INTENT(OUT)  :: NITNOx 
       REAL,    INTENT(OUT)  :: NITNO
       REAL,    INTENT( OUT ) :: F_HONO
       REAL,    INTENT( OUT ) :: F_NO ! nitrifcation and denitrification
       REAL,    INTENT( OUT ) :: F_N2O ! nitrifcation and denitrification
       REAL,    INTENT( OUT ) :: DENTR 
       REAL,    INTENT( OUT ) :: NTR 
!-----------------------------------------------------------------------------

! Algorithm adapted from Huang and Gerber 2015, DAYcent (Del Grosso et
! al, 2000 and Parton et al., 2001) 
      !Soil diffusivity at field capacity
          REAL  :: KDENT
          REAL  :: dt


         Real    :: fTg    ! nitrification temperature factor
         Real    :: fSWg   ! nitrification Soil Water factor
         Real    :: fpHg   ! nitrification pH factor
         Real    :: Kn     ! nitrification rate 1/s
         Real    :: Kvs    ! Air-soil exchange rate for aqueous NH4+
         Real    :: kvg    ! Air-soil exchange rate for gas phase NH3
         Real    :: MNH3   ! molar atmospheric NH3 conc.
         Real    :: MNHx   ! molar soil water NH4+ + NH3 conc.
         Real    :: wg25   ! wilting point +0.25*(field capacity-wilting point)
!         Real    :: pHsl   ! Soil pH
         Real    :: ag_tot ! total
         Integer :: i   ! loop counter
         Real( 8 )         :: dp
         Real( 8 )         :: WFPS
         Real( 8 )         :: fWFPS
         Real( 8 )         :: fNO3toC   
         Real( 8 )         :: Dr      ! relative gas diffusitivity in soil comapred to air
      ! Declare local constant Pi
!         REAL, PARAMETER :: Pi = 3.1415927 

         Real( 8 )   :: k
         Real( 8 )   :: fWFPSDEN
         Real( 8 )   :: fTDEN
         Real( 8 )   :: fNO3D
         Real( 8 )   :: fSWC
         Real( 8 )   :: fEaT
      ! New soil biomes based on Ostwald et al., 2013
      INTEGER, PARAMETER :: OSW_NSOIL= 17  !Oswald et al, 2013: 17 biome type
      INTEGER, PARAMETER :: NSOIL    = 24  !USGS 24 LU/biome type  
      INTEGER          SOILCAT            ! soil category    
      Integer, Save      :: logdev      
! HONO:NO ratio for each of the 17 soil biomes [in fraction] FigS1
! Oswald et al., 2013
!      REAL*8,  PARAMETER :: A_HONO(OSW_NSOIL)        =                (/
!
!     &   0.11, 0.09, 0.00, 0.17, 0.27, 0.39, 0.43, 0.22, 0.02, 
!     &   0.51, 0.38, 0.85, 0.47, 0.60, 0.42, 0.45, 0.63     /)
      REAL*8,  PARAMETER :: A_HONO = 0.429
      INTEGER, PARAMETER :: MAXSTYPES = 11
C Saturation values for 11 soil types from pxpbl.F  (MCIP PX version)
C Pleim-Xiu Land-Surface and PBL Model (PX-LSM)
C See Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.
      REAL :: SATURATION( MAXSTYPES ) =
     &                  (/ 0.395, 0.410, 0.435, 0.485,
     &                     0.451, 0.420, 0.477, 0.476,
     &                     0.426, 0.482, 0.482 /)

         logdev =  init3()
     
      dt = FLOAT( TIME2SEC( TSTEP( 2 ) ) )

!      Write(logdev,*) 'dwat ', dwat, 'wsat ', GRID_DATA%WSAT( c,r )
!      Write(logdev,*) 'wfc ', GRID_DATA%WFC( c,r ), 'bslp ', GRID_DATA%BSLP( c,r )
! soil diffusitivity at field capacity in cm2/s in Del Grosso et al 2000
      dp  = dwat * GRID_DATA%WSAT( c,r )**2
     &       * ( 1.0 - GRID_DATA%WFC( c,r ) / GRID_DATA%WSAT( c,r ) ) 
     &       **( 2.0 + 3.0 / GRID_DATA%BSLP( c,r ) )



!******************************************* Nitrification Rate****************************************************
! Estimate the soil nitrification rate following Reddy et al 1979 starting with
! the temperature parameter
         fTg = max( 0.041 * ( MET_DATA%Tempg( C,R ) - 278.15 ), 0.0 )
 
! Estimate the soil water parameter
         wg25 = GRID_DATA%WWLT( c,r ) + 0.25 * ( GRID_DATA%WFC( c,r ) - GRID_DATA%WWLT( c,r ) )
         If ( Met_Data%SOIM1( c,r ) .Le. GRID_DATA%WWLT( c,r ) ) fSWg = 0.1
         If ( Met_Data%SOIM1( c,r ) .Lt. wg25 .And. Met_Data%SOIM1( c,r ) .Gt. GRID_DATA%WWLT( c,r ) ) Then
            fSWg = max( 0.1, 0.1 + 0.9 * Sqrt( ( Met_Data%SOIM1( c,r ) - GRID_DATA%WWLT( c,r ) ) /
     &                ( GRID_DATA%WFC( c,r ) - GRID_DATA%WWLT( c,r ) ) ), ( Met_Data%SOIM1( c,r ) - GRID_DATA%WWLT( c,r ) ) /
     &                ( 0.25 * ( GRID_DATA%WFC( c,r ) - GRID_DATA%WWLT( c,r ) ) ) )
         End If
         If ( Met_Data%SOIM1( c,r ) .Ge. wg25 .And. Met_Data%SOIM1( c,r ) .Lt. GRID_DATA%WFC( c,r ) ) fSWg = 1.0

         If ( Met_Data%SOIM1( c,r ) .Ge. GRID_DATA%WFC( c,r ) ) Then
            fSWg = max( 0.1, 1.0 - ( Met_Data%SOIM1( c,r ) - GRID_DATA%WFC( c,r ) ) / 
     &            ( GRID_DATA%WSAT( c,r )-GRID_DATA%WFC( c,r ) ) )
         End If
! Estimate the pH factor
         If ( pHsl( c,r ) .Lt. 7.0 ) fpHg = 0.307 * pHsl( c,r ) - 1.269
         If ( pHsl( c,r ) .Ge. 7.0 .And. pHsl( c,r ) .Lt. 7.4 ) fpHg = 1.0
         If ( pHsl( c,r ) .Ge. 7.4) fpHg = 5.367 - 0.599 * pHsl( c,r )

!         Write(logdev,*) 'fTg ', fTg, 'fSWg ', fSWg, 'fpHg ', fpHg,'pH', pHsl(c,r)

         Kn = min(0.69,  fTg * fSWg * fpHg ) / 24.0 / 3600.0  ! Kn is in 1/d in EPIC convert to 1/s
        
         NTR = NH4( c,r ) * ( 1.0 - EXP(-kn*dt) )/dt       !Average Nitrified NH4 kg/ha/s
         NH4( c,r ) = NH4( c,r ) * EXP(-kn*dt)                  ! updated NH4 pool
      
!********************************************* Denitrification-Nitrfication fluxes NO N2O ********************************************
!Fractional water filled pore space
         WFPS = (MET_DATA%SOIM1( c,r ) - GRID_DATA%WRES( c,r ))/ 
     &               (GRID_DATA%WSAT( c,r )-GRID_DATA%WRES( c,r ))
         WFPS = min(1.0, max(WFPS,0.0))
!Relative gas diffusitivity in soil w.r.t. air (Huang and Gerber, 2015)
!         Dr  = 0.209 * ((1.0-WFPS)**(4.0/3.0)) 
         Dr  = dwat * GRID_DATA%WSAT( c,r )**2
     &       * ( max(1.0 - MET_DATA%SOIM1( c,r ) / GRID_DATA%WSAT( c,r ),0.0) ) 
     &       **( 2.0 + 3.0 / GRID_DATA%BSLP( c,r ) )
!         Write(logdev,*) 'Dr: ', Dr
!NO:N2Oratio Parton et al., 2001 Del Grosso et al., 2000 same as DayCENT model       
         RNOTON2O = 15.2 + ((35.5*ATAN(0.68*Pi*((10.0*Dr)-1.86)))/Pi)
!         Write(logdev,*) 'RNOTON2O: ', RNOTON2O

!Nitrification N2O flux   
         NITN2O = 0.02 * NTR * XCELL_GD * YCELL_GD / 100.0 / 100.0 * 1.0e3 * 3600.0 ! from CMAQ ABFLUX , Parton et al, 2001 kg/ha/s to g N/hr
        
!Parton et al. 2001 used YL pulsing, here BDSNP module pulsing is used
!Nitrification NO flux        
         NITNOx = RNOTON2O * NITN2O * PULSE ! Parton et al, 2001
!         Write(logdev,*) 'NITNOx: ', NITNOx


!soil texture dependent parameter (Del Grosso et al., 2000)
         k = max ( 1.7, (38.4 - (350 * dp )) )  
!-----Denitification N2:N2O ratio Calculation------------------------------!
!         Write(logdev,*) 'NO3', NO3(c,r), 'LiableC',LiableC( c,r ), 'k', k
         if(LiableC( c,r ) .gt. 0.0 ) Then
            fNO3toC = max(0.16 * k, k * exp(-0.8*(NO3( c,r )/LiableC( c,r ))))   !NO3:C availability function
         else 
            fNO3toC = 0.16 * k
         end if
        
         fWFPS   = max ( 0.1, (0.015* WFPS* 100-(0.32)))  !WFPS factor
         

         RDENN2TON2O = fNO3toC * fWFPS   
!-----------Denitrification rate for NO N2O flux calulation--------------------------------!

         fNO3D = 1.15 * (NO3( c,r )**0.57) ! del grosso et al 2000 , NO3 in microg N per g soil
           !fCDEN = 0.1 * (LiableC ^ 1.3)
!         fWFPSDEN = 1.56/ (12.0**(16.0/(12.0**(2.01 * WFPS )))) !WFPS funcn for Denitr rate calculation 
! Parton et al 1996 WFPS function used by del Grosso et al 2000 for medium texture soil (should be more applicable than sand commented out above and textural functions should be added)
! additionally this funciton should be bounded between 0 and 1
         fWFPSDEN = min(1.0, 4.82/ (14.0**(16.0/(12.0**(1.39 * WFPS ))))) !WFPS funcn for Denitr rate calculation 
!         Write(logdev,*) 'fWFPSDEN: ', fWFPSDEN

C         fTDEN    = min(1.0,EXP(308.56*(1.0/68.02-1.0/(MET_DATA%SOIT1( c,r )-227.13)))) !Temp funcn for Denitr rate calculation
         fTDEN    = max(0.0,(MET_DATA%SOIT1( c,r )-273.15)/
     &          (MET_DATA%SOIT1( c,r )-273.15+EXP(5.059-0.2504*
     &          (MET_DATA%SOIT1( c,r )-273.15))))

!         Write(logdev,*) 'fTDEN: ', fTDEN

! Denitrification rate in kg N/(m2 year) Huang and Gerber Biogeosci 2015
! doi:10.5194/bg-12-6405-2015

!         KDENT = fTDEN * fWFPSDEN * 8750.0 * (LiableC( c,r )*NO3( c,r
!         ))/((LiableC( c,r )+0.0017*10000.0)*

! use the EPIC daily denitrification rate

!         KDENT = fTDEN * fWFPSDEN * 1.4 * ( LiableC( c,r ) *
!     &          NO3( c,r ) ) / ( (LiableC( c,r ) +
!     &          ((0.0017 * 10000.0 * 24.0 * 3600.0)/dt)) *
!     &          (NO3( c,r ) + ((0.0083*10000.0 * 24.0 * 3600.0)/dt)) ) 
         KDENT = fTDEN * fWFPSDEN * 1.4 * ( LiableC( c,r ) *
     &          NO3( c,r ) ) / ( (LiableC( c,r ) + ((0.0017 * 10000.0
     &          ))) * (NO3( c,r ) + ((0.0083*10000.0))) )
!         KDENT = fTDEN * fWFPSDEN * 1.4 * ( LiableC( c,r ) *
!     &          NO3( c,r ) ) / ( (LiableC( c,r ) +
!     &          (0.0017 * 10000.0 )) *
!     &          (NO3( c,r ) + (0.0083*10000.0) ) )

!         KDENT = min(0.69,KDENT) 

!         Write(logdev,*) 'fTDEN: ', fTDEN
! Denitrification rate in kg N/(m2 year) Huang and Gerber Biogeosci 2015 doi:10.5194/bg-12-6405-2015
!         KDENT = fTDEN * fWFPSDEN * 8750.0 * (LiableC( c,r )*NO3( c,r ))/((LiableC( c,r )+0.0017*10000.0)*
! use the EPIC daily denitrification rate
C         KDENT = fTDEN * fWFPSDEN * 1.4 * (LiableC( c,r )*NO3( c,r ))/((LiableC( c,r )+0.0017*10000.0)*
C     &          (NO3( c,r )+0.0083*10000.0))  
!         Write(logdev,*) 'KDENT: ', KDENT
! convert to 1/s assume 365 days in a year 
!         KDENT = KDENT/365.0/24.0/3600.0
! convert to 1/s from 1/d 
         KDENT = min(0.01,KDENT)/24.0/3600.0
!         Write(logdev,*) 'KDENT: ', KDENT
! Integrate for an exponential decay assuming that NO3 production on the daily time scale is neglegible.
!         write( logdev, *) 'KDENT', KDENT, 'dt ',dt 
         if(KDENT .Gt. 0.0 ) Then
            DENTR =  NO3( c,r ) * (1.0 - EXP(-KDENT * dt) )/dt ! average 1 per s
            NO3( c,r ) = NTR/KDENT + (NO3( c,r )-NTR/KDENT) * EXP(-KDENT * dt)
!            write( logdev, *) 'DENTR', DENTR, 'NO3 ',NO3  
         else 
            DENTR = 0.0
         end if
! Hauer and Gerber 2015 , kg N per m2 per yr .0017 and 0.0083 in kg N
! per m2

!NO N2O fluxes from Denitrification
         DENITN2O = DENTR/( 1.0 + RDENN2TON2O) * XCELL_GD * YCELL_GD / 100.0 / 100.0 * 1.0e3 * 3600.0 !Denitrification N2O flux kg N/ha/s to g N / hr
         DENITNO  = RNOTON2O * DENITN2O      !Denitrification NO flux g N / hour
!         Write(logdev,*) 'DENITNO: ', DENITNO

! *************************************** fraction of HONO emissions as a function of fractional soil water content from BDSNP_MOD_EPIC.F
c       SOILCAT = INT( Grid_Data%SLTYP( C,R ) )
c       Met_Data%SOIT1(C,R)  

!*******************************************************
! HONO SWC (THETA) dependency         
!*******************************************************
       IF ( WFPS .LE. 0.1) THEN  
          fSWC = (A_HONO * WFPS)/0.1  !Assuming linear increase till 10% SWC
        ELSEIF ( WFPS .LE. 0.40 ) THEN
          fSWC = A_HONO*(0.4-WFPS)/(0.4-0.1) 
        ELSE
          fSWC = 0.0
       ENDIF
!      fEaT = exp((80.0/0.00831447)*((1.0/298.15)-(1.0/Met_Data%SOIT1(C,R))))
! New NItrification HONO and NO
      F_HONO = fSWC * NITNOx
      NITNO = NITNOx - F_HONO
      F_NO = NITNO + DENITNO
!      F_NO = NITNO
      F_N2O = NITN2O + DENITN2O
!      F_N2O = NITN2O
!      Write(logdev,*) 'fSWC: ', fSWC

       if( IsNaN( F_NO ) ) Then
          Write(logdev,*) 'NITNO:       ', NITNO
          Write(logdev,*) 'DENITN2O:    ', DENITN2O
          Write(logdev,*) 'RNOTON2O:    ', RNOTON2O
          Write(logdev,*) 'RDENN2TON2O: ', RDENN2TON2O
          Write(logdev,*) 'DENTR:       ', DENTR
          Write(logdev,*) 'NTR:         ', NTR
       End If

      Return
!------------------------------------------------------------------!
!NO emissions as in BDSNP/EPIC Algorithm (BDSNP_MOD.F)
C          NOPOL( C,R ) = SOILNOX * CELLAREA * 3600.0 * 10.0**-9 ![ngN/m2/s] * m2 * s/hr * g/ng
      END Subroutine Get_NFlux

         Logical Function IsNaN( a ) ! required for Portland Group compiler (pgi)
            Real :: a
            If ( a .Eq. a ) Then   ! requires -Kieee flag for pgi
!              write( *,* ) '==IsNaN false: ', a
               IsNaN = .false.
            Else
!              write( *,* ) '==IsNaN true: ', a
               IsNaN = .true.
            End If
            Return
         End Function IsNaN  ! error, if pgf90
!        End  ! error, if ifort


       END MODULE N_CYCLE_MOD


